-- A3Pv2.8/test2_INC8/weird_unit.vhdl
-- created mer. déc. 25 22:13:38 CET 2019 by whygee@f-cpu.org
--
-- This is not a functional or useful unit but it contains cases
-- that should be caught by the tools.
--
-- Released under the GNU AGPLv3 license

Library ieee;
    use ieee.std_logic_1164.all;
Library work;
    use work.all;
Library proasic3;
    use proasic3.all;

entity VG_Wrapper is
  generic (
    -- overridden by the VG code so it doesn't matter that much
    VectGenWidthIn : integer := 50;
    VectGenWidthOut: integer := 50
  );
  port(
    VectIn : in  std_logic_vector(VectGenWidthIn -1 downto 0);
    VectOut: out std_logic_vector(VectGenWidthOut-1 downto 0);
    VectClk: in std_logic
  );
end VG_Wrapper;

architecture Weird of VG_Wrapper is
  signal sig1, sig2, sig3, sig4, sig5 : std_logic;
begin

  -- a set/reset flip-flop :
  ff1: entity NAND2 port map(A=>VectIn(0), B=>sig2, Y=>sig1);
  ff2: entity NAND2 port map(A=>VectIn(1), B=>sig1, Y=>sig2);
  VectOut(0) <= sig1;
  VectOut(1) <= sig2;

  -- a transparent latch:
  mx0: entity MX2 port map(A=>VectIn(2), B=>sig3,      S=>VectIn(3), Y=>sig3);
  dummy: entity AND2 port map(A=>sig3,   B=>VectIn(4), Y=>sig4);
  VectOut(2) <= sig4;

  -- output #3 is not connected
  --VectOut(3) <= 'U';

  -- input #4 is not connected

  -- unconnected output : unobservable
  open1: entity AND2 port map(A=>VectIn(5), B=>VectIn(6), Y=>sig5);
  -- > to test if the general depth is reduced when finding a "long" unconnected network:
  open2: entity AND2 port map(A=>sig5,      B=>VectIn(7), Y=>OPEN);

  -- unconnected inputs : uncontrollable
  open3: entity AND2 port map(A=>'U', B=>'U', Y=>VectOut(4));

  -- autosize:
  VectOut(5) <= '1';
  VectOut(VectGenWidthOut-1) <= VectIn(8);
end Weird;
