-- A3Pv2.8/test2_INC8/Wrap_ALU8dec.vhdl
-- version dim. déc.  8 08:07:34 CET 2019 : forked from INC8_tb.vhdl
-- version lun. déc. 16 02:52:27 CET 2019 : derived from Wrap_INC8.vhdl
-- version mar. déc. 24 21:13:49 CET 2019 : forked from Wrap_ALU8.vhdl
--
-- wraps both the decoder and the ALU8
-- Released under the GNU AGPLv3 license

Library ieee;
    use ieee.std_logic_1164.all;
Library work;
    use work.all;

entity VG_Wrapper is
  generic (
    -- overridden by the VG code so it doesn't matter that much
    VectGenWidthIn : integer := 27;
    VectGenWidthOut: integer := 19
  );
  port(
    VectIn : in  std_logic_vector(VectGenWidthIn -1 downto 0);
    VectOut: out std_logic_vector(VectGenWidthOut-1 downto 0);
    VectClk: in std_logic
  );
end VG_Wrapper;

architecture Wrap_ALU8dec of VG_Wrapper is

  signal --CarryFlag,
      Cin, Cout, NEG, PassMask, OrXor, Rop2Mx, CMPS : std_logic;
  signal Inst : std_logic_vector(15 downto 0);

begin

  -- here we "wire" the unit to the Vector Generator ports:
  tbdec: entity DEC_ALU8 port map (
    Inst      => Inst,
--    CarryFlag => CarryFlag,
    CMPS      => CMPS,
    Rop2Mx    => Rop2Mx,
    OrXor     => OrXor,
    PassMask  => PassMask,
    NEG       => NEG,
    Cin       => Cin);

  tb: entity ALU8 port map (
     CMPS     => CMPS,
     Rop2Mx   => Rop2Mx,
     OrXor    => OrXor,
     PassMask => PassMask,
     NEG      => NEG,
     Cin      => Cin,
     SRI      => VectIn(7 downto 0),
     SND      => VectIn(15 downto 8),
     SUM      => VectOut(7 downto 0),
     ROP2     => VectOut(15 downto 8),
     Cout     => VectOut(16));
  Inst <= VectIn(25 downto 20) & "UUU" & VectIn(19 downto 16) & "UUU";

  -- the wires that enable size autodetection
  VectOut(17) <= '1';
  VectOut(VectGenWidthOut-1) <= VectIn(26);
end Wrap_ALU8dec;
